package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.World;
	
	/**
	 * ...
	 * @author Darien Sumner
	 */
	public class Space extends World
	{
		public static var elapsedTime:int = 0;
		public static var currentTime:int = 0;
		public static var speedMod:Number = 1;
		
		public static var running:Boolean = true;
		public static var addLose:Boolean = false;
		public static var addWin:Boolean = false;
		public static var doReset:Boolean = false;
		
		public var countdown:Number = 10;
		public var distance:Number = 365;
		
		public var countdownText:Number;
		public var distanceText:Number;
		
		public var e:Entity = new Entity;
		public var d:Entity = new Entity;
		
		public var game:Boolean = false;
		
		public var eLabel:Entity = new Entity;
		public var dLabel:Entity = new Entity;
		
		Text.size = 48;
		
		public function Space() 
		{
			add(new Background());
			add(new Background2());
			add(new Background3());
			add(new Background4());
			add(new Blackscreen());
			
			add(new Title());
		}
		
		public function reset():void
		{
			removeAll();
			
			countdown = 10;
			distance = 365;
			elapsedTime = 0;
			currentTime = 0;
			speedMod = 0;
			
			addLose = false;
			addWin = false;
			
			
			e.graphic = new Text(countdown.toString());
			e.x = 500;
			e.y = 0;
			
			eLabel.graphic = new Text("Remaining seconds:");
			eLabel.x = 0;
			eLabel.y = 0;
			
			d.graphic = new Text(distance.toString());
			d.x = 500;
			d.y = 550;
			
			dLabel.graphic = new Text("Remaining days:");
			dLabel.x = 0;
			dLabel.y = 550;
			
			add(new Background());
			add(new Background2());
			add(new Background3());
			add(new Background4());
			add(new Blackscreen());
				
			add(e);
			add(d);
			add(eLabel);
			add(dLabel);
			
			add(new Spaceship(50, FP.halfHeight));
			add(new Flame(16, FP.halfHeight));
			
			running = true;
			game = true;
			doReset = false;
			
		}
		
		override public function update():void
		{
			if (doReset)
			{
					reset();
					return;
			}
			
			if (running)
			{
				var i:Number = FP.random;
				elapsedTime++;
				currentTime++;
				
				if (game)
				{
					speedMod = (currentTime / 360) + 1;
					
					if (currentTime / 200000 <= .0045)
					{
						countdown += currentTime / 200000;
					}
					else
					{
						countdown += .0045;
					}
					countdown -= .005;
					
					countdownText = ((Math.round(countdown * 100)) / 100);
					
					distance -= speedMod / 30;
					distanceText = ((Math.round(distance * 100)) / 100);
					
					e.graphic = new Text(countdownText.toString());
					d.graphic = new Text(distanceText.toString());
					
					if (countdown <= 0)
					{
						running = false;
						addLose = true;
						countdown = 0;
						e.graphic = new Text("0");
					}
					
					else if (distance <= 0)
					{
						running = false;
						addWin = true;
						distance = 0;
						d.graphic = new Text("0");
					}
				}
					
				if (i >= .985)
				{
					add(new Meteor);
				}
				
				else if (i >= .96)
				{
					add(new Missile);
				}
				
				else if (i >= .945)
				{
					add(new UFO);
				}
			}
			
			super.update();
		}
		
	}

}