package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Darien Sumner
	 */
	public class Spaceship extends Entity
	{
		[Embed(source = "../assets/spaceship.png")] private const IMGSPACESHIP:Class;
		public var sprSpaceship:Image;
		
		[Embed(source = '../assets/impact.mp3')] private const SFXIMPACT:Class;
		public var impact:Sfx = new Sfx(SFXIMPACT);
				
		public function Spaceship(x:int, y:int) 
		{
				this.graphic = sprSpaceship = new Image(IMGSPACESHIP);
				this.x = x;
				this.y = y;
				
				this.type = "Player";
				setHitbox(42, 23);
				
		}
		
		override public function update():void
		{
			if (!Space.running)
			{
				return;
			}
			
			if (Input.check(Key.UP))
			{
					this.y -= 3;
			}
			
			if (Input.check(Key.DOWN))
			{
					this.y += 3;
			}
			
			if (Input.check(Key.LEFT))
			{
					this.x -= 3;
			}
			
			if (Input.check(Key.RIGHT))
			{
				this.x += 3;
			}
				
				
			if (collide("Hazard", this.x, this.y) || this.x < 0 || this.x > FP.width - this.width || this.y < 0 || this.y > FP.height - this.height)
			{
				Space.currentTime = 0;
				if (collide("Hazard", this.x, this.y) && !impact.playing)
				{
					impact.play();
					impact.volume = 0.5;
				}
			}
			
		}
		
	}

}